#ifndef __SQAS3_OBJ_H_
#define __SQAS3_OBJ_H_

#include <sqobject.h>
#include "asvariant.h"

/**
 * AS3IuWFNgێsquirrelNX
 */
class AS3Object : public sqobject::Object {

public:
	/**
	 * p
	 */
	static void init(HSQUIRRELVM vm);

	/**
	 * Ip
	 */
	static void done();

	/**
	 * X^bNAS3CX^X܂̓NX̎擾
	 * @param v squirrelVM
	 * @param idx CfbNX
	 * @return AS3IuWFNgiNX܂̓CX^Xj
	 */
	static bool getInstance(HSQUIRRELVM v, SQInteger idx, AS3Variant &instance);

	/**
	 * X^bNւAS3CX^X̓o^
	 * @return o^ true
	 */
	static bool pushInstance(HSQUIRRELVM v, AS3Variant &instance);

	/**
	 * NXo^
	 */
	static bool registerFlashClass(HSQUIRRELVM v, AS3Variant &asClassObj);

protected:
	// RXgN^
	AS3Object(HSQUIRRELVM v);

	// RXgN^
	// CX^XԂꍇp
	AS3Object(HSQUIRRELVM v, AS3Variant &instance);
	
	// fXgN^
	~AS3Object();

	/**
	 * IuWFNg̃[T
	 */
	static SQRESULT release(SQUserPointer up, SQInteger size);

	/**
	 * AS3IuWFNg̃RXgN^
	 * 1 IuWFNg
	 * 2` 
	 * Rϐ1 NX
	 */
	static SQRESULT constructor(HSQUIRRELVM v);

	/**
	 * AS3IuWFNgp̃\bh
	 * 1 IuWFNg
	 * 2`z
	 * Rϐ1 o
	 */
	static SQRESULT invoker(HSQUIRRELVM v);

	/**
	 * AS3IuWFNgp̃vpeBQb^[
	 * 1 IuWFNg
	 * Rϐ1 vpeB
	 */
	static SQRESULT getter(HSQUIRRELVM v);

	/**
	 * AS3IuWFNgp̃vpeBZb^[
	 * 1 IuWFNg
	 * 2 ݒl
	 * Rϐ1 vpeB
	 */
	static SQRESULT setter(HSQUIRRELVM v);

	/**
	 * AS3IuWFNgp̃\bh
	 * 1 IuWFNg
	 * 2`z
	 * Rϐ1 NX
	 * Rϐ2 o
	 */
	static SQRESULT staticInvoker(HSQUIRRELVM v);

	/**
	 * AS3IuWFNgp̃vpeBQb^[
	 * 1 IuWFNg
	 * Rϐ1 NX
	 * Rϐ2 vpeB
	 */
	static SQRESULT staticGetter(HSQUIRRELVM v);

	/**
	 * AS3IuWFNgp̃vpeBZb^[
	 * 1 IuWFNg
	 * 2 ݒl
	 * Rϐ1 NX
	 * Rϐ2 vpeB
	 */
	static SQRESULT staticSetter(HSQUIRRELVM v);

	// NXo^
	static void registerClass(HSQUIRRELVM v, AS3Variant &asClassObj, bool first);
	static void registerFunction(HSQUIRRELVM v, AS3Variant *asClassObj, const char *functionName);
	static void registerProperty(HSQUIRRELVM v, AS3Variant *asClassObj, const char *propertyName, int type);
	
	enum PropertyType {
		PROPERTY_READ = 0x01,
		PROPERTY_WRITE = 0x02
	};
	
private:
 	// o^ꂽNX̖O}bv
	static sqobject::ObjectInfo classMap;

	// NXp[T
	static AS3Variant typeParser;

	// ΏۃIuWFNg
	AS3Variant instance;
};

#endif
