/**
 * get type information of ActionScript class
 */
public class TypeParser {
	
	public function TypeParser() {
	}

	public function getAccess(access:String):int {
		var n:int;
		if (access == "readonly") {
			n = 1;
		} else if (access == "writeonly") {
			n = 2;
		} else {
			n = 3;
		}
		return n;
	}
	
	public function getTypeInfo(objClass:Class):Array {
		var result:Array = new Array();
		var typeInfo:XML = flash.utils.describeType(objClass);
		// class
		for each (var info:XML in typeInfo.factory.extendsClass) {
			result.unshift(new Array(1, info.@type));
		}
		// static
		for each (var info:XML in typeInfo.accessor) {
			result.unshift(new Array(2, info.@name, getAccess(info.@access)));
		}
		for each (var info:XML in typeInfo.method) {
			result.unshift(new Array(3, info.@name));
		}
		// instance
		for each (var info:XML in typeInfo.factory.accessor) {
			result.push(new Array(4, info.@name, getAccess(info.@access)));
		}
		for each (var info:XML in typeInfo.factory.method) {
			result.push(new Array(5, info.@name));
		}
		return result;
	}
}
