__asm__(
"// support functions\n"
"\n"
"/**\n"
" * ActionScript type checker\n"
" */\n"
"public function getType(value:*):int\n"
"{\n"
"	var type:String = typeof value;\n"
"	if (type == \"undefined\") {\n"
"		return 0;\n"
"	} else if (type == \"null\") {\n"
"		return 1;\n"
"	} else if (type == \"boolean\") {\n"
"		return 2;\n"
"	} else if (type == \"function\") {\n"
"		return 3;\n"
"	} else if (type == \"number\") {\n"
"		return value is int || value is uint ? 4 : 5;\n"
"	} else if (type == \"object\") {\n"
"		return value == null ? 1 : 6;\n"
"	} else if (type == \"string\") {\n"
"		return 7;\n"
"	} else if (type == \"xml\") {\n"
"		return 8;\n"
"	} else {\n"
"		return 9;\n"
"	}\n"
"}\n"
"\n"
"public function isClass(value:*):Boolean\n"
"{\n"
"	return value instanceof Class;\n"
"}\n"
"\n"
"/**\n"
" * ActionScript Object compare\n"
" */\n"
"public function equals(a:*, b:*):Boolean\n"
"{\n"
"	return a === b;\n"
"}\n"
"\n"
);
